import javax.servlet.*;
import javax.servlet.http.*;
import java.util.*;
import java.io.*;

public class Bilancio extends HttpServlet {
	private String path;

        class ContoCorrente {
                public int bilancio;
        }

        ContoCorrente conto;

        public void init(ServletConfig conf) throws ServletException {
                super.init(conf);
                conto = new ContoCorrente();

		try {
			path=getServletContext().getRealPath("")+"/"+getInitParameter("nomeFile");
			DataInputStream f=new DataInputStream(new FileInputStream(path));
			conto.bilancio=f.readInt();
			f.close();
		} catch (IOException e) { conto.bilancio=Integer.parseInt(getInitParameter("valoreConto")); }

        }
                
        public void doGet(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {
                res.setContentType("text/html");
                PrintWriter out = res.getWriter();
                out.println("<HTML><BODY>");
                out.println("<H2>Java Bank</H2>");
                out.println("Bilancio corrente: <B>" + conto.bilancio +
                            "</B><BR>");
                out.println("<FORM METHOD=\"post\" ACTION=\"Bilancio\">");
                out.println("Ammontare: <INPUT TYPE=\"text\" NAME=\"Ammontare\""+
                            " SIZE=\"3\"><BR>");
                out.println("<INPUT TYPE=\"submit\" NAME=\"Deposito\""+
                            " VALUE=\"Deposito\">");
                out.println("<INPUT TYPE=\"submit\" NAME=\"Prelievo\""+
                            " VALUE=\"Prelievo\">");
                out.println("</FORM>");
                out.println("</BODY></HTML>");
        }
        
        public void doPost(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {
                int ammontare=0;
                
                try {
                        ammontare = Integer.parseInt(req.getParameter("Ammontare"));
                } catch (NullPointerException e) {
                        // Ammontare dell'operazione non specificato
                } catch (NumberFormatException e) {
                        // Ammontare dell'operazione non valido
                }
                
                synchronized(conto) { // inizio del blocco sincronizzato
                        if(req.getParameter("Prelievo") != null && (ammontare <= conto.bilancio))
                                conto.bilancio = conto.bilancio - ammontare;

                        if(req.getParameter("Deposito") != null && (ammontare > 0))
                                conto.bilancio = conto.bilancio + ammontare;
                } // fine del blocco sincronizzato
                
                doGet(req, res); // ripresenta il form
        }
        
        public void destroy() {
		try {
			DataOutputStream f=new DataOutputStream(new FileOutputStream(path));
			f.writeInt(conto.bilancio);
			f.close();
		} catch (IOException e) { }
        }
        
}